org.apache.hc.client5.http.impl.classic

## Class CloseableHttpClient

- java.lang.Object
- - org.apache.hc.client5.http.impl.classic.CloseableHttpClient

- All Implemented Interfaces:
    Closeable, AutoCloseable, HttpClient, org.apache.hc.core5.io.ModalCloseable
  Direct Known Subclasses:
    MinimalHttpClient

      @Contract(threading=SAFE)
      public abstract class CloseableHttpClient
      extends Object
      implements HttpClient, org.apache.hc.core5.io.ModalCloseable

  Base implementation of `HttpClient` that also implements `ModalCloseable`.
  Since:
    4.3

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CloseableHttpClient()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract CloseableHttpResponse` | `doExecute(org.apache.hc.core5.http.HttpHost target, org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.protocol.HttpContext context)`
    `CloseableHttpResponse` | `execute(org.apache.hc.core5.http.ClassicHttpRequest request)` Executes HTTP request using the default context.
    `<T> T` | `execute(org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)` Executes a request using the default context and processes the response using the given response handler.
    `CloseableHttpResponse` | `execute(org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.protocol.HttpContext context)` Executes HTTP request using the given context.
    `<T> T` | `execute(org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.protocol.HttpContext context, org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)` Executes a request using the default context and processes the response using the given response handler.
    `CloseableHttpResponse` | `execute(org.apache.hc.core5.http.HttpHost target, org.apache.hc.core5.http.ClassicHttpRequest request)` Executes HTTP request using the default context.
    `<T> T` | `execute(org.apache.hc.core5.http.HttpHost target, org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)` Executes a request using the default context and processes the response using the given response handler.
    `CloseableHttpResponse` | `execute(org.apache.hc.core5.http.HttpHost target, org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.protocol.HttpContext context)` Executes HTTP request using the given context.
    `<T> T` | `execute(org.apache.hc.core5.http.HttpHost target, org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.core5.http.protocol.HttpContext context, org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)` Executes a request using the default context and processes the response using the given response handler.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.hc.core5.io.ModalCloseable

      `close`

    - ### Methods inherited from interface java.io.Closeable

      `close`

- - ### Constructor Detail

    - #### CloseableHttpClient

          public CloseableHttpClient()

  - ### Method Detail

    - #### doExecute

          protected abstract CloseableHttpResponse doExecute(org.apache.hc.core5.http.HttpHost target,
                                        org.apache.hc.core5.http.ClassicHttpRequest request,
                                        org.apache.hc.core5.http.protocol.HttpContext context)
                                                      throws IOException

      Throws:
        `IOException`

    - #### execute

          public CloseableHttpResponse execute(org.apache.hc.core5.http.HttpHost target,
                                      org.apache.hc.core5.http.ClassicHttpRequest request,
                                      org.apache.hc.core5.http.protocol.HttpContext context)
                                        throws IOException

      Description copied from interface: `HttpClient`
      Executes HTTP request using the given context.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          public CloseableHttpResponse execute(org.apache.hc.core5.http.ClassicHttpRequest request,
                                      org.apache.hc.core5.http.protocol.HttpContext context)
                                        throws IOException

      Description copied from interface: `HttpClient`
      Executes HTTP request using the given context.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          public CloseableHttpResponse execute(org.apache.hc.core5.http.ClassicHttpRequest request)
                                        throws IOException

      Description copied from interface: `HttpClient`
      Executes HTTP request using the default context.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `request` - the request to execute
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          public CloseableHttpResponse execute(org.apache.hc.core5.http.HttpHost target,
                                      org.apache.hc.core5.http.ClassicHttpRequest request)
                                        throws IOException

      Description copied from interface: `HttpClient`
      Executes HTTP request using the default context.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
      Returns:
        the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
      Throws:
        `IOException` - in case of a problem or the connection was aborted

    - #### execute

          public <T> T execute(org.apache.hc.core5.http.ClassicHttpRequest request,
                      org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)
                    throws IOException

      Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `request` - the request to execute
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          public <T> T execute(org.apache.hc.core5.http.ClassicHttpRequest request,
                      org.apache.hc.core5.http.protocol.HttpContext context,
                      org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)
                    throws IOException

      Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `request` - the request to execute
        `responseHandler` - the response handler
        `context` - the context to use for the execution, or `null` to use the default context
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          public <T> T execute(org.apache.hc.core5.http.HttpHost target,
                      org.apache.hc.core5.http.ClassicHttpRequest request,
                      org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)
                    throws IOException

      Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

    - #### execute

          public <T> T execute(org.apache.hc.core5.http.HttpHost target,
                      org.apache.hc.core5.http.ClassicHttpRequest request,
                      org.apache.hc.core5.http.protocol.HttpContext context,
                      org.apache.hc.core5.http.io.HttpClientResponseHandler<? extends T> responseHandler)
                    throws IOException

      Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `HttpClientResponseHandler`s from having to manage resource deallocation internally.
      Specified by:
        `execute` in interface `HttpClient`
      Parameters:
        `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
        `request` - the request to execute
        `context` - the context to use for the execution, or `null` to use the default context
        `responseHandler` - the response handler
      Returns:
        the response object as generated by the response handler.
      Throws:
        `IOException` - in case of a problem or the connection was aborted
        `ClientProtocolException` - in case of an http protocol error

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.